#include <stdio.h>

struct node {
	int num;
	struct node *next, *prev;
};

	struct node *
build_ring(n)
	int n;
{
	int i;
	struct node *head, *curr = 0, *new;
	
	for (i=1 ; i <= n ; i++) {
		new = (struct node *) malloc(sizeof(*new));
		new->num = i;
		new->next = new->prev = 0;
		if (curr) {
			curr->next = new;
			new->prev = curr;
		} else {
			head = new;
		}
		curr = new;
	}
	curr->next = head;
	head->prev = curr;
	return head;
}


	struct node *
move(np, k, ignore)
	struct node *np;
	int k, ignore;
{
	while (k > 1) {
		np = np->next;
		if (np->num != ignore) {
			k--;
		}
	}
	return np;
}


main()
{
	int k, n;
	struct node *ring;
	struct node *dead, *bury;
	int i, nleft;

	while (scanf(" %d %d", &n, &k), n != 0 && k != 0) {

		for (i=0 ; i < n ; i++) {
			ring = build_ring(n);
			ring = move(ring, i+1, -1);
			nleft = n;
			while (nleft > 1) {
				dead = move(ring, k, -1);
				bury = move(dead->next, k, dead->num);
				dead->num = bury->num;
				bury->prev->next = bury->next;
				bury->next->prev = bury->prev;
				ring = dead->next;
				nleft--;
			}
			if (ring->num == 1) {
				break;
			}
		}
		if (i == n) {
			printf("No safe starting position\n");
		} else {
			printf("%d\n", i+1);
		}
	}
}
		
